package ExprModel;

public class Operators extends Model.Operators
{
  


  public Model.State Nil()
  { State s=new State(); s.e=new NilExpr();
    return s;
  }


  public Model.State Fus(String a,String b)
  { Name na=new Name(); na.n=a;
    Name nb=new Name(); nb.n=b;
    FusionExpr fe=new FusionExpr(); fe.n1=na; fe.n2=nb;
    State s=new State(); s.e=fe;
    return s;
  }

  public Model.State Par(Model.State ssa,Model.State ssb)
  { State sa=(State)ssa, sb=(State)ssb;
    Exprs es=new Exprs(); es.addElement(sa.e); es.addElement(sb.e);
    ParExpr pe=new ParExpr(); pe.es=es;
    State s=new State(); s.e=pe;
    return s;
  }
  
  public Model.State Sum(Model.State ssa,Model.State ssb)
  { State sa=(State)ssa, sb=(State)ssb;
    Exprs es=new Exprs(); es.addElement(sa.e); es.addElement(sb.e);
    SumExpr se=new SumExpr(); se.es=es;
    State s=new State(); s.e=se;
    return s;
  }


  public Model.State Res(String[] rs,Model.State ss)
  { State s=(State)ss; Names ns=new Names();
    for (int i=0; i<rs.length; i++) {Name n=new Name(); n.n=rs[i]; ns.addElement(n);}
    ResExpr re=new ResExpr(); re.e=s.e; re.n=ns;
    State rets=new State(); rets.e=re;
    return rets;
  }


  public Model.State Rep(Model.State ss)
  { State s=(State)ss;
    RepExpr re=new RepExpr(); re.e=s.e;
    State rs=new State(); rs.e=re;
    return rs;
  }

  public Model.State Snd(String n,String[] dat,boolean isbound,Model.State P)
  { State s=(State)P;
    XmitExpr xe=new XmitExpr();
    xe.chan=new Name(); xe.chan.n=n; xe.issend=true;
    xe.dat=dat; xe.isbound=isbound; xe.e=s.e;
    State rs=new State(); rs.e=xe;
    return rs;
  }

  public Model.State Rcv(String n,String[] dat,boolean isbound,Model.State P)
  { State s=(State)P;
    XmitExpr xe=new XmitExpr();
    xe.chan=new Name(); xe.chan.n=n; xe.issend=false;
    xe.dat=dat; xe.isbound=isbound; xe.e=s.e;
    State ss=new State(); ss.e=xe;
    return ss;
  }

}
