package Model;

// Read the file "readme.txt" to find out what a state is.

public abstract class State
{
  // Play (optional). Translates the current state into the calculus.
  public abstract State Play(Operators ops) throws Exception;

  // EnumEqSteps, EnumExSteps -- return a list of possible steps.
  // (of reduction steps, and structural congruence steps).
  // The precise type of the object is model-specific.
  // Step -- given one of these objects, performs it.
  public java.util.Vector EnumEqSteps() {return null;}
  public java.util.Vector EnumExSteps() {return null;}
  public void Step(Object o) throws Exception {}

  public String toString() {return "[]";}
}
