package Ptrs;

// !(nu xx)( P | Q ... | !(R) | !(S) | T+U ...)
// xx is 'res'
// xmits is P, Q
// reps is R, S
// sums is T+U, 
//
// we don't need a link to a higher rep node, because we ourselves
// will never be consumed (and so will never need to ask for another
// copy of ourselves)

public class Rep
{ Name[] res=new Name[0];
  Xmit[] xmits=new Xmit[0]; Rep[] reps=new Rep[0]; Sum[] sums=new Sum[0];
}

class Reps extends java.util.Vector
{ public final synchronized Rep repAt(int i)
  { return (Rep)elementAt(i);
  }
  public final synchronized void unionElement(Rep s)
  { if (!contains(s)) addElement(s);
  }  
}